/* 12th Of August 2008 */
/*
 * Permission is given to modify this code for the purpose
 * of enhancing Richard Rognlie's PBMSERV, either by adding new
 * functionality to the Oshi module, or as a base for a new game.  If you
 * wish to use the code for any other purposes, ASK!  
*/

/* 
   Author: Martin Moller Skarbiniks Pedersen
   Userid: chaz 
   Email:  traxplayer@gmail.com
*/

#ifndef OSHI_H
#define OSHI_H

#include "board2d.h"
#include "lists.h"

class Oshi: public Board2D {
protected:
  int ToTier(const char &c);
  int ToTier(const int &row,const int &col);
  char Colour(const int &x,const int &y);
  char Colour(const char &c);
  unsigned int RedTiersCaptured();
  unsigned int WhiteTiersCaptured();
  void CopyBoardToStorage1();
  void CopyBoardToStorage2();
  void CopyStorage1ToBoard();
  void CopyStorage2ToBoard();
  void CopyStorage2ToStorage1();
  char * Push(const int &row, const int &col, const int &dir_row,const int &dir_col);
  unsigned int HowManyPushed(int row, int col,int dir_row,int dir_col,const int &spaces);
  const bool InsideBoard(const int &row, const int &col) const;
  const bool CheckPiece(const char &c);
public:
  virtual char Blank(void) { return '.'; }
  virtual void PrintBoard(FILE *fp);
  virtual const char *MakeMove(const char *move);
  virtual int IsGameOver(const char *&winner);
  virtual const char *PlayerNames(int n); 
  // Non-board specific
  virtual const char *GameType(void) { return "Oshi"; }
  virtual int Init(void);
};  

#endif
